/*
**	$Id: PathPanel.c,v 1.4 92/04/21 16:59:20 olsen Sta Locker: olsen $
**	$Revision: 1.4 $
**	$Date: 92/04/21 16:59:20 $
**
**	Editing panel for path configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_CONFIGSTORE,GAD_SELECT1,GAD_TUPLOAD,GAD_SELECT2,GAD_TDOWNLOAD,
		GAD_SELECT3,GAD_AUPLOAD,GAD_SELECT4,GAD_ADOWNLOAD,GAD_SELECT5,
		GAD_BUPLOAD,GAD_SELECT6,GAD_BDOWNLOAD,GAD_SELECT7,GAD_CAPTURE,
		GAD_SELECT8,GAD_LOG,GAD_SELECT9,GAD_EDITOR,GAD_SELECT10,GAD_BEEP,
		GAD_SELECT11,GAD_USE,GAD_CANCEL };

#define WIDTH	630
#define HEIGHT	192

STATIC UBYTE *SelectText[] =
{
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	LocalizeString(SelectText,MSG_PATHPANEL_SELECT_CONFIG_STORAGE_DIR_TXT,MSG_PATHPANEL_SELECT_TERMINAL_BEEP_SOUND_TXT);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_Width		= 264;
		NewGadget . ng_Height		= 14;
		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_CONFIGURATION_STORAGE_DIR_GAD);
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= 1 + TopEdge;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> DefaultStorage,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_UPLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> TextUploadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_DOWNLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> TextDownloadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> ASCIIUploadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_ASCII_DOWNLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> ASCIIDownloadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_BINARY_UPLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> BinaryUploadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_BINARY_DOWNLOAD_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> BinaryDownloadPath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_CAPTURE_PATH_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> CapturePath,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_LOG_FILE_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> LogFile,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_EDITOR_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> Editor,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_TERMINAL_BEEP_SOUND_GAD);
		NewGadget . ng_Width		= 264;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= 266;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Config -> BeepSound,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SELECT_TXT);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 2;
		NewGadget . ng_Width		= 88;	/* NEW 52 */

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			TAG_DONE);

		NewGadget . ng_Width		= 88;	/* NEW 52 */
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= HEIGHT - 3 - NewGadget . ng_Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= WIDTH - 10 - NewGadget . ng_Width;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
PathPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width - WIDTH) >> 1,
			WA_Top,		(Screen -> Height - HEIGHT) >> 1,
			WA_Width,	WIDTH,
			WA_Height,	HEIGHT,

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | BUTTONIDCMP | STRINGIDCMP,

			WA_Title,	LocaleString(MSG_PATHPANEL_PATH_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

GadCheck:				if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:		Terminated = TRUE;

										strcpy(Config -> DefaultStorage,	GT_STRING(GadgetArray[GAD_CONFIGSTORE]));

										strcpy(Config -> TextUploadPath,	GT_STRING(GadgetArray[GAD_TUPLOAD]));
										strcpy(Config -> TextDownloadPath,	GT_STRING(GadgetArray[GAD_TDOWNLOAD]));

										strcpy(Config -> ASCIIUploadPath,	GT_STRING(GadgetArray[GAD_AUPLOAD]));
										strcpy(Config -> ASCIIDownloadPath,	GT_STRING(GadgetArray[GAD_ADOWNLOAD]));

										strcpy(Config -> BinaryUploadPath,	GT_STRING(GadgetArray[GAD_BUPLOAD]));
										strcpy(Config -> BinaryDownloadPath,	GT_STRING(GadgetArray[GAD_BDOWNLOAD]));

										strcpy(Config -> CapturePath,		GT_STRING(GadgetArray[GAD_CAPTURE]));
										strcpy(Config -> LogFile,		GT_STRING(GadgetArray[GAD_LOG]));
										strcpy(Config -> Editor,		GT_STRING(GadgetArray[GAD_EDITOR]));
										strcpy(Config -> BeepSound,		GT_STRING(GadgetArray[GAD_BEEP]));

										break;

							case GAD_CANCEL:	Terminated = TRUE;

										CopyMem(&PrivateConfig,Config,sizeof(struct Configuration));

										break;

							default:                if(Gadget -> GadgetID & 1)
										{
											UBYTE DummyBuffer[256],*DummyChar;
											struct FileRequester *FileRequest;
											LONG Selection = (Gadget -> GadgetID - 1);

											BlockWindow(PanelWindow);

											strcpy(DummyBuffer,GT_STRING(GadgetArray[Selection]));

											if(Gadget -> GadgetID >= GAD_SELECT9)
											{
												if(DummyBuffer[0])
												{
													if(FilePart(DummyBuffer) == DummyBuffer)
														DummyBuffer[0] = 0;
													else
													{
														DummyChar = PathPart(DummyBuffer);

														*DummyChar = 0;
													}

													DummyChar = FilePart(GT_STRING(GadgetArray[Selection]));
												}
												else
													DummyChar = "";
											}
											else
												DummyChar = "";

											if(FileRequest = GetFile(SelectText[Selection >> 1],DummyBuffer,DummyChar,DummyBuffer,NULL,FALSE,FALSE,(Selection >> 1) > 7 ? FALSE : TRUE,LocaleString(MSG_GLOBAL_SELECT_TXT)))
											{
												GT_SetGadgetAttrs(GadgetArray[Selection],PanelWindow,NULL,
													GTST_String,(Gadget -> GadgetID < GAD_SELECT9 ? FileRequest -> rf_Dir : DummyBuffer),
												TAG_DONE);

												FreeAslRequest(FileRequest);
											}

											ReleaseWindow(PanelWindow);
										}

										break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	return((BYTE)Stricmp(Config -> BeepSound,PrivateConfig . BeepSound));
}
